// +------------------------------------------------------------------+
// |                                     Timeframe_zoom_per_chart.mq4 |
// |                                                  Girard Matthieu |
// |                                             https://www.mql5.com |
// +------------------------------------------------------------------+
#property copyright "Girard Matthieu / modified by Jagg"
#property link      "https:   // www.mql5.com"
#property version   "1.4"
#property strict
#property indicator_chart_window

struct SChartProperties
  {
  //--- Chart Properties from Dialog
  int    scale;
  bool   isFixedScale;
  bool   tradelevel;
  } ChartProperties;

bool Init=false;

extern ENUM_BASE_CORNER Corner = CORNER_LEFT_LOWER;   // Corner
extern color Border_Color_Active = clrDodgerBlue;            // Border Color (Active)
extern color Border_Color_Inactive = clrDimGray;            // Border Color (Inactive)
extern color Background_Color_Active = C'32,39,48';        // Background Color (Active)
extern color Background_Color_Inactive = C'32,39,48';        // Background Color (Inactive)
extern color Text_Color_Active = clrDodgerBlue;        // Text Color (Active)
extern color Text_Color_Inactive = clrSilver;        // Text Color (Inactive)
color Text_Color_Inactive2 = clrDimGray;        // Text Color (Inactive)
extern int Text_Font_Size = 7;              // Font Size
extern int XShift_2 = 2;              // X Shift (horizontal)
extern int YShift_2 = 2;              // Y Shift (vertical)
extern int ButtonMarginSize = 2;      // Space between buttons
extern string _ = "***********************";
extern bool Show_M1 = true;   // Show M1 Button
extern bool Show_M5 = true;   // Show M5 Button
extern bool Show_M15 = true;   // Show M15 Button
extern bool Show_M30 = true;   // Show M30 Button
extern bool Show_H1 = true;   // Show H1 Button
extern bool Show_H4 = true;   // Show H4 Button
extern bool Show_D1 = true;   // Show D1 Button
extern bool Show_W1 = true;   // Show W1 Button
extern bool Show_MN1 = true;   // Show MN Button
extern bool Show_Zi = true;   // Show Zoom In Button
extern bool Show_Zo = true;   // Show Zoom Out Button
extern bool Show_ChartScaleFix = true;   // Show Chart ScaleFix Button
extern bool Show_TradeLevel = false;   // Show Trade Level Button


int XShift = 1;     // Horizontal shift
int XShift2 = 1;
int YShift = 16;     // Vertical shift

// ---
color chart_color_background_active, chart_color_background_inactive;
double DPIScaling;

// +------------------------------------------------------------------+
// | Custom indicator initialization function                         |
// +------------------------------------------------------------------+
int OnInit() {

   //ChartSetInteger(0, CHART_SCALEFIX, 0, FALSE);
   
   ChartProperties.isFixedScale     = (bool)ChartGetInteger(0,CHART_SCALEFIX);
   ChartProperties.scale            = (int)ChartScaleGet();//ChartGetInteger(0,CHART_SCALE);
   ChartProperties.tradelevel       = (int)ChartGetInteger(0,CHART_SHOW_TRADE_LEVELS);
   
   // Terminal DPI scaling
   int desktopScreenDPI = TerminalInfoInteger(TERMINAL_SCREEN_DPI);

   DPIScaling = desktopScreenDPI > 96.0 ? desktopScreenDPI / 96.0 : 1.0;

   // ButtonMarginSize = (int)(ButtonMarginSize*DPIScaling);

   if ((Corner == CORNER_RIGHT_LOWER) || (Corner == CORNER_RIGHT_UPPER)) {
      XShift = 26;     // Horizontal shift
      XShift2 = 26;
   }
   if (Corner == CORNER_RIGHT_UPPER) {
      YShift = 20;     // Vertical shift
   }
   // if(XShift_2!=0) XShift+=(int)(XShift_2*DPIScaling);
   if (XShift_2!=0) {
      XShift += XShift_2;
      XShift2 += XShift_2;
   }
   if (YShift_2!=0) {
      YShift += YShift_2;
   }


   if (Background_Color_Active == clrNONE) {
      chart_color_background_active = (color)ChartGetInteger(0, CHART_COLOR_BACKGROUND, 0);
   } else {
      chart_color_background_active = Background_Color_Active;
   }
   if (Background_Color_Inactive == clrNONE) {
      chart_color_background_inactive = (color)ChartGetInteger(0, CHART_COLOR_BACKGROUND, 0);
   } else {
      chart_color_background_inactive = Background_Color_Inactive;
   }


   if (Show_Zi) {
      ButtonCreate(0, "TZPC_ZommInButton", 0, XShift, YShift, 25, 15, Corner, "Z+", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
      ObjectSetString(0, "TZPC_ZommInButton", OBJPROP_TOOLTIP, "Zoom In");
      XShift += ButtonMarginSize;
   } else {
      XShift = MathMin(XShift - 26, 1);
   }
   if (Show_Zo) {
      ButtonCreate(0, "TZPC_ZommOutButton", 0, 26 + XShift, YShift, 25, 15, Corner, "Z-", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
      ObjectSetString(0, "TZPC_ZommOutButton", OBJPROP_TOOLTIP, "Zoom Out");
      XShift += ButtonMarginSize;
   } else {
      XShift = MathMin(XShift - 26, 1);
   }

   if (Show_ChartScaleFix) {
      if(ChartGetInteger(0, CHART_SCALEFIX, 0) == TRUE)
      {
         ButtonCreate(0, "TZPC_ScaleFix", 0, XShift2, YShift+16+ButtonMarginSize, 25, 15, Corner, "CS", "Arial", Text_Font_Size + 1, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
            ObjectSetString(0, "TZPC_ScaleFix", OBJPROP_TOOLTIP, "Turn OFF Chart ScaleFix");
         ButtonCreate(0, "TZPC_ScaleFix+", 0, XShift2 + 26 + ButtonMarginSize, YShift+16+ButtonMarginSize, 25, 15, Corner, "CS+", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
            ObjectSetString(0, "TZPC_ScaleFix+", OBJPROP_TOOLTIP, "ScaleFix [+]");
         ButtonCreate(0, "TZPC_ScaleFix-", 0, XShift2 + 52 + 2*ButtonMarginSize, YShift+16+ButtonMarginSize, 25, 15, Corner, "CS-", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
            ObjectSetString(0, "TZPC_ScaleFix-", OBJPROP_TOOLTIP, "ScaleFix [-]");   
      } else {
          ButtonCreate(0, "TZPC_ScaleFix", 0, XShift2, YShift+16+ButtonMarginSize, 25, 15, Corner, "CS", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
            ObjectSetString(0, "TZPC_ScaleFix", OBJPROP_TOOLTIP, "Turn ON Chart ScaleFix");    
      }
   }

   if (Show_TradeLevel) {
      if(ChartGetInteger(0, CHART_SHOW_TRADE_LEVELS, 0) == TRUE)
      {
         ButtonCreate(0, "TZPC_TradeLevel", 0, XShift2, YShift+16*2+ButtonMarginSize*2, 25, 15, Corner, "TL", "Arial", Text_Font_Size + 1, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
            ObjectSetString(0, "TZPC_TradeLevel", OBJPROP_TOOLTIP, "Turn OFF Trade Levels");
      } else {
          ButtonCreate(0, "TZPC_TradeLevel", 0, XShift2, YShift+16*2+ButtonMarginSize*2, 25, 15, Corner, "TL", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
            ObjectSetString(0, "TZPC_TradeLevel", OBJPROP_TOOLTIP, "Turn ON Trade Levels");
      }
   }
   
   // --- M1 button
   if (Show_M1) {
      if (Period()==PERIOD_M1) {
         ButtonCreate(0, "TZPC_M1Button", 0, 52 + XShift, YShift, 25, 15, Corner, "M1", "Arial", Text_Font_Size, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
      } else {
         ButtonCreate(0, "TZPC_M1Button", 0, 52 + XShift, YShift, 25, 15, Corner, "M1", "Arial", 7, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
      }
      ObjectSetString(0, "TZPC_M1Button", OBJPROP_TOOLTIP, "Switch to M1 period");
      XShift += ButtonMarginSize;
   } else {
      XShift = MathMin(XShift - 26, 1);
   }
   // --- M5 button
   if (Show_M5) {
      if (Period()==PERIOD_M5) {
         ButtonCreate(0, "TZPC_M5Button", 0, 78 + XShift, YShift, 25, 15, Corner, "M5", "Arial", Text_Font_Size, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
      } else {
         ButtonCreate(0, "TZPC_M5Button", 0, 78 + XShift, YShift, 25, 15, Corner, "M5", "Arial", Text_Font_Size, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
      }
      ObjectSetString(0, "TZPC_M5Button", OBJPROP_TOOLTIP, "Switch to 5 Minutes period");
      XShift += ButtonMarginSize;
   } else {
      XShift = MathMin(XShift - 26, 1);
   }
   // --- M15 button
   if (Show_M15) {
      if (Period()==PERIOD_M15) {
         ButtonCreate(0, "TZPC_M15Button", 0, 104 + XShift, YShift, 25, 15, Corner, "M15", "Arial", Text_Font_Size, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
      } else {
         ButtonCreate(0, "TZPC_M15Button", 0, 104 + XShift, YShift, 25, 15, Corner, "M15", "Arial", Text_Font_Size, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
      }
      ObjectSetString(0, "TZPC_M15Button", OBJPROP_TOOLTIP, "Switch to 15 Minutes period");
      XShift += ButtonMarginSize;
   } else {
      XShift = MathMin(XShift - 26, 1);
   }
   // --- M30 button
   if (Show_M30) {
      if (Period()==PERIOD_M30) {
         ButtonCreate(0, "TZPC_M30Button", 0, 130 + XShift, YShift, 25, 15, Corner, "M30", "Arial", Text_Font_Size, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
      } else {
         ButtonCreate(0, "TZPC_M30Button", 0, 130 + XShift, YShift, 25, 15, Corner, "M30", "Arial", Text_Font_Size, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
      }
      ObjectSetString(0, "TZPC_M30Button", OBJPROP_TOOLTIP, "Switch to 30 Minutes period");
      XShift += ButtonMarginSize;
   } else {
      XShift = MathMin(XShift - 26, 1);
   }
   // --- H1 button
   if (Show_H1) {
      if (Period()==PERIOD_H1) {
         ButtonCreate(0, "TZPC_H1Button", 0, 156 + XShift, YShift, 25, 15, Corner, "H1", "Arial", Text_Font_Size, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
      } else {
         ButtonCreate(0, "TZPC_H1Button", 0, 156 + XShift, YShift, 25, 15, Corner, "H1", "Arial", Text_Font_Size, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
      }
      ObjectSetString(0, "TZPC_H1Button", OBJPROP_TOOLTIP, "Switch to 1 Hour period");
      XShift += ButtonMarginSize;
   } else {
      XShift = MathMin(XShift - 26, 1);
   }
   // --- H4 button
   if (Show_H4) {
      if (Period()==PERIOD_H4) {
         ButtonCreate(0, "TZPC_H4Button", 0, 182 + XShift, YShift, 25, 15, Corner, "H4", "Arial", Text_Font_Size, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
      } else {
         ButtonCreate(0, "TZPC_H4Button", 0, 182 + XShift, YShift, 25, 15, Corner, "H4", "Arial", Text_Font_Size, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
      }
      ObjectSetString(0, "TZPC_H4Button", OBJPROP_TOOLTIP, "Switch to 4 Hours period");
      XShift += ButtonMarginSize;
   } else {
      XShift = MathMin(XShift - 26, 1);
   }
   // --- D1 button
   if (Show_D1) {
      if (Period()==PERIOD_D1) {
         ButtonCreate(0, "TZPC_D1Button", 0, 208 + XShift, YShift, 25, 15, Corner, "D1", "Arial", Text_Font_Size, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
      } else {
         ButtonCreate(0, "TZPC_D1Button", 0, 208 + XShift, YShift, 25, 15, Corner, "D1", "Arial", Text_Font_Size, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
      }
      ObjectSetString(0, "TZPC_D1Button", OBJPROP_TOOLTIP, "Switch to 1 Day period");
      XShift += ButtonMarginSize;
   } else {
      XShift = MathMin(XShift - 26, 1);
   }
   // --- W1 button
   if (Show_W1) {
      if (Period()==PERIOD_W1) {
         ButtonCreate(0, "TZPC_W1Button", 0, 234 + XShift, YShift, 25, 15, Corner, "W1", "Arial", Text_Font_Size, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
      } else {
         ButtonCreate(0, "TZPC_W1Button", 0, 234 + XShift, YShift, 25, 15, Corner, "W1", "Arial", Text_Font_Size, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
      }
      ObjectSetString(0, "TZPC_W1Button", OBJPROP_TOOLTIP, "Switch to 1 Week period");
      XShift += ButtonMarginSize;
   } else {
      XShift = MathMin(XShift - 26, 1);
   }
   // --- MN button
   if (Show_MN1) {
      if (Period()==PERIOD_MN1) {
         ButtonCreate(0, "TZPC_MNButton", 0, 260 + XShift, YShift, 25, 15, Corner, "MN", "Arial", Text_Font_Size, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
      } else {
         ButtonCreate(0, "TZPC_MNButton", 0, 260 + XShift, YShift, 25, 15, Corner, "MN", "Arial", Text_Font_Size, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
      }
      ObjectSetString(0, "TZPC_MNButton", OBJPROP_TOOLTIP, "Switch to 1 Month period");
      XShift += ButtonMarginSize;
   } else {
      XShift = MathMin(XShift - 26, 1);
   }

   return(INIT_SUCCEEDED);
}

// +------------------------------------------------------------------------------------------------------------------------------------------------------+
void OnDeinit(const int Reason) {
   ObjectsDeleteAll(0, "TZPC");
}
// +------------------------------------------------------------------+
// | Custom indicator iteration function                              |
// +------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]){
   // --- return value of prev_calculated for next call
   if(Init) return(rates_total);
   Init  = true;
   
   return(rates_total);
}
// +------------------------------------------------------------------+
// | ChartEvent function                                              |
// +------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   if(!Init) return;
   
   if (id==CHARTEVENT_OBJECT_CLICK) {
      if (sparam=="TZPC_ZommInButton") {
         int current_chartscale = ChartScaleGet();
         ChartScaleSet(MathMin(5, current_chartscale + 1));
         ObjectSetInteger(0, "TZPC_ZommInButton", OBJPROP_STATE, false);
         // if ((ChartScaleGet()==5) || (ChartScaleGet()==4)) {
         // ObjectSetInteger(0,"TZPC_ZommInButton",OBJPROP_COLOR,Text_Color_Inactive2);
         // } else {
         // ObjectSetInteger(0,"TZPC_ZommInButton",OBJPROP_COLOR,Text_Color_Inactive);
         // ObjectSetInteger(0,"TZPC_ZommOutButton",OBJPROP_COLOR,Text_Color_Inactive);
         // }
         return;
      }
      if (sparam=="TZPC_ZommOutButton") {
         int current_chartscale = ChartScaleGet();
         ChartScaleSet(MathMax(0, current_chartscale - 1));
         ObjectSetInteger(0, "TZPC_ZommOutButton", OBJPROP_STATE, false);
         // if ((ChartScaleGet()==1) || (ChartScaleGet()==0)) {
         // ObjectSetInteger(0,"TZPC_ZommOutButton",OBJPROP_COLOR,Text_Color_Inactive2);
         // } else {
         // ObjectSetInteger(0,"TZPC_ZommInButton",OBJPROP_COLOR,Text_Color_Inactive);
         // ObjectSetInteger(0,"TZPC_ZommOutButton",OBJPROP_COLOR,Text_Color_Inactive);
         // }
         return;
      }
      if (sparam=="TZPC_M1Button") {
         ChartSetSymbolPeriod(ChartID(), _Symbol, PERIOD_M1);
         // ObjectSetInteger(0,"TZPC_M1Button",OBJPROP_COLOR,clrBlack);
         // ObjectSetInteger(0,"TZPC_M1Button",OBJPROP_BGCOLOR,clrWhite);
         // ObjectSetInteger(0,"TZPC_M1Button",OBJPROP_BORDER_COLOR,clrBlack);
         ObjectSetInteger(0, "TZPC_M1Button", OBJPROP_STATE, false);
         return;
      }
      if (sparam=="TZPC_M5Button") {
         ChartSetSymbolPeriod(ChartID(), _Symbol, PERIOD_M5);
         // ObjectSetInteger(0,"TZPC_M5Button",OBJPROP_COLOR,clrBlack);
         // ObjectSetInteger(0,"TZPC_M5Button",OBJPROP_BGCOLOR,clrWhite);
         // ObjectSetInteger(0,"TZPC_M5Button",OBJPROP_BORDER_COLOR,clrBlack);
         ObjectSetInteger(0, "TZPC_M5Button", OBJPROP_STATE, false);
         return;
      }
      if (sparam=="TZPC_M15Button") {
         ChartSetSymbolPeriod(ChartID(), _Symbol, PERIOD_M15);
         // ObjectSetInteger(0,"TZPC_M15Button",OBJPROP_COLOR,clrBlack);
         // ObjectSetInteger(0,"TZPC_M15Button",OBJPROP_BGCOLOR,clrWhite);
         // ObjectSetInteger(0,"TZPC_M15Button",OBJPROP_BORDER_COLOR,clrBlack);
         ObjectSetInteger(0, "TZPC_M15Button", OBJPROP_STATE, false);
         return;
      }
      if (sparam=="TZPC_M30Button") {
         ChartSetSymbolPeriod(ChartID(), _Symbol, PERIOD_M30);
         // ObjectSetInteger(0,"TZPC_M30Button",OBJPROP_COLOR,clrBlack);
         // ObjectSetInteger(0,"TZPC_M30Button",OBJPROP_BGCOLOR,clrWhite);
         // ObjectSetInteger(0,"TZPC_M30Button",OBJPROP_BORDER_COLOR,clrBlack);
         ObjectSetInteger(0, "TZPC_M30Button", OBJPROP_STATE, false);
         return;
      }
      if (sparam=="TZPC_H1Button") {
         ChartSetSymbolPeriod(ChartID(), _Symbol, PERIOD_H1);
         // ObjectSetInteger(0,"TZPC_H1Button",OBJPROP_COLOR,clrBlack);
         // ObjectSetInteger(0,"TZPC_H1Button",OBJPROP_BGCOLOR,clrWhite);
         // ObjectSetInteger(0,"TZPC_H1Button",OBJPROP_BORDER_COLOR,clrBlack);
         ObjectSetInteger(0, "TZPC_H1Button", OBJPROP_STATE, false);
         return;
      }
      if (sparam=="TZPC_H4Button") {
         ChartSetSymbolPeriod(ChartID(), _Symbol, PERIOD_H4);
         // ObjectSetInteger(0,"TZPC_H4Button",OBJPROP_COLOR,clrBlack);
         // ObjectSetInteger(0,"TZPC_H4Button",OBJPROP_BGCOLOR,clrWhite);
         // ObjectSetInteger(0,"TZPC_H4Button",OBJPROP_BORDER_COLOR,clrBlack);
         ObjectSetInteger(0, "TZPC_H4Button", OBJPROP_STATE, false);
         return;
      }
      if (sparam=="TZPC_D1Button") {
         ChartSetSymbolPeriod(ChartID(), _Symbol, PERIOD_D1);
         // ObjectSetInteger(0,"TZPC_D1Button",OBJPROP_COLOR,clrBlack);
         // ObjectSetInteger(0,"TZPC_D1Button",OBJPROP_BGCOLOR,clrWhite);
         // ObjectSetInteger(0,"TZPC_D1Button",OBJPROP_BORDER_COLOR,clrBlack);
         ObjectSetInteger(0, "TZPC_D1Button", OBJPROP_STATE, false);
         return;
      }
      if (sparam=="TZPC_W1Button") {
         ChartSetSymbolPeriod(ChartID(), _Symbol, PERIOD_W1);
         // ObjectSetInteger(0,"TZPC_W1Button",OBJPROP_COLOR,clrBlack);
         // ObjectSetInteger(0,"TZPC_W1Button",OBJPROP_BGCOLOR,clrWhite);
         // ObjectSetInteger(0,"TZPC_W1Button",OBJPROP_BORDER_COLOR,clrBlack);
         ObjectSetInteger(0, "TZPC_W1Button", OBJPROP_STATE, false);
         return;
      }
      if (sparam=="TZPC_MNButton") {
         ChartSetSymbolPeriod(ChartID(), _Symbol, PERIOD_MN1);
         // ObjectSetInteger(0,"TZPC_MNButton",OBJPROP_COLOR,clrBlack);
         // ObjectSetInteger(0,"TZPC_MNButton",OBJPROP_BGCOLOR,clrWhite);
         // ObjectSetInteger(0,"TZPC_MNButton",OBJPROP_BORDER_COLOR,clrBlack);
         ObjectSetInteger(0, "TZPC_MNButton", OBJPROP_STATE, false);
         return;
      }
      
      //Button Chart Scale
      if(sparam == "TZPC_ScaleFix") {
         if(ChartGetInteger(0, CHART_SCALEFIX, 0) == TRUE)
         {
            //Print("SCALEFIX was true => NOW FALSE");
            ChartSetInteger(0, CHART_SCALEFIX, 0, FALSE);
            ObjectDelete(ChartID(),"TZPC_ScaleFix+");
            ObjectDelete(ChartID(),"TZPC_ScaleFix-");
            ObjectDelete(ChartID(),"TZPC_ScaleFix");
            ButtonCreate(0, "TZPC_ScaleFix", 0, XShift2, YShift+16+ButtonMarginSize, 25, 15, Corner, "CS", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
            ObjectSetString(0, "TZPC_ScaleFix", OBJPROP_TOOLTIP, "Turn ON Chart ScaleFix");    
            ChartRedraw(0);
         } else {
            //Print("SCALEFIX was FALSE => NOW TRUE");
            int chart_space_in_percent = 10;
            int iLeft   = WindowFirstVisibleBar();
            int iRight  = iLeft-WindowBarsPerChart();
            if(iRight < 0) iRight = 0;     // Chart shifted
                    
            double bars_price_max = High[iHighest(NULL,0,MODE_HIGH, iLeft-iRight+1,iRight)];
            //if (bars_price_max_tmp == 0) bars_price_max_tmp = ChartPriceMax(); //<- added static var in OnTick
            double bars_price_min = Low[iLowest(NULL,0,MODE_LOW, iLeft-iRight+1,iRight)];
            //if (bars_price_min_tmp == 0) bars_price_min_tmp = ChartPriceMin(); //<- added static var in OnTick
            //Print("Danach => ChartPriceMax(): ",ChartPriceMax()," ChartPriceMin(): ",ChartPriceMin());
            
            //double chart_price_max = bars_price_max - (( bars_price_max - bars_price_min ) / (100-2*chart_space_in_percent)*chart_space_in_percent);
            //double chart_price_min = bars_price_min + (( bars_price_max - bars_price_min ) / (100-2*chart_space_in_percent)*chart_space_in_percent);
            //double chart_price_max_to_min_diff_half = ((chart_price_max-chart_price_min)/2);
            
            double chart_price_max_to_min_diff_half = ((bars_price_max-bars_price_min)/2);
            double chart_price_max_adjusted_close_in_the_middle = Close[0] + chart_price_max_to_min_diff_half;
            double chart_price_min_adjusted_close_in_the_middle = Close[0] - chart_price_max_to_min_diff_half;
            
            ChartSetInteger(0, CHART_SCALEFIX, 0, TRUE);
            ChartSetDouble(0, CHART_FIXED_MAX, chart_price_max_adjusted_close_in_the_middle);
            ChartSetDouble(0, CHART_FIXED_MIN, chart_price_min_adjusted_close_in_the_middle);
            
            ObjectDelete(ChartID(),"TZPC_ScaleFix");
            ButtonCreate(0, "TZPC_ScaleFix", 0, XShift2, YShift+16+ButtonMarginSize, 25, 15, Corner, "CS", "Arial", Text_Font_Size + 1, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
            ObjectSetString(0, "TZPC_ScaleFix", OBJPROP_TOOLTIP, "Turn OFF Chart ScaleFix");
            ButtonCreate(0, "TZPC_ScaleFix+", 0, XShift2 + 26 + ButtonMarginSize, YShift+16+ButtonMarginSize, 25, 15, Corner, "CS+", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
            ButtonCreate(0, "TZPC_ScaleFix-", 0, XShift2 + 52 + 2*ButtonMarginSize, YShift+16+ButtonMarginSize, 25, 15, Corner, "CS-", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
            
            ChartRedraw(0);
         }
      }   
      
      //Button [+] Chart Scale
      if(sparam == "TZPC_ScaleFix+") {
         ChartSetDouble(0, CHART_FIXED_MAX, ChartPriceMax()-((ChartPriceMax()-ChartPriceMin())/5));
         ChartSetDouble(0, CHART_FIXED_MIN, ChartPriceMin()+((ChartPriceMax()-ChartPriceMin())/5));  
         ObjectSetInteger(0, "TZPC_ScaleFix+", OBJPROP_STATE, false); 
         ChartRedraw(0);
         return;
      }
      
      //Button [-] Chart Scale
      if(sparam == "TZPC_ScaleFix-") {
         ChartSetDouble(0, CHART_FIXED_MAX, ChartPriceMax()+((ChartPriceMax()-ChartPriceMin())/5));
         ChartSetDouble(0, CHART_FIXED_MIN, ChartPriceMin()-((ChartPriceMax()-ChartPriceMin())/5));
         ObjectSetInteger(0, "TZPC_ScaleFix-", OBJPROP_STATE, false);
         ChartRedraw(0);
         return;
      }
   }

   //Button Trade Level
   if(sparam == "TZPC_TradeLevel") {
      int h = (int)ChartGetInteger(0,CHART_SHOW_TRADE_LEVELS);
      ObjectDelete(ChartID(),"TZPC_TradeLevel");
      if(h!=0) {
         // hide trade levels
         ChartSetInteger(ChartID(), CHART_SHOW_TRADE_LEVELS, false);
         ButtonCreate(0, "TZPC_TradeLevel", 0, XShift2, YShift+16*2+ButtonMarginSize*2, 25, 15, Corner, "TL", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
            ObjectSetString(0, "TZPC_TradeLevel", OBJPROP_TOOLTIP, "Turn ON Trade Levels");
      } else {
         // show trade levels
         ChartSetInteger(ChartID(), CHART_SHOW_TRADE_LEVELS, true);
         ButtonCreate(0, "TZPC_TradeLevel", 0, XShift2, YShift+16*2+ButtonMarginSize*2, 25, 15, Corner, "TL", "Arial", Text_Font_Size + 1, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
            ObjectSetString(0, "TZPC_TradeLevel", OBJPROP_TOOLTIP, "Turn OFF Trade Levels");
      }
   }
   
   if(id == CHARTEVENT_CHART_CHANGE) {
      //--- Detect a change of the trade level property 'from outside' (user or another indicator changed trade level property)
      if (Show_TradeLevel) {
         int tl = (int)ChartGetInteger(0,CHART_SHOW_TRADE_LEVELS);
         if(tl!=ChartProperties.tradelevel) {
            //Print("CHANGE DETECTED on TRADE LEVLE ",tl);
            ObjectDelete(ChartID(),"TZPC_TradeLevel");
            ChartProperties.tradelevel = tl;
            if(!tl) {
               // hide trade levels
               ChartSetInteger(ChartID(), CHART_SHOW_TRADE_LEVELS, false);
               ButtonCreate(0, "TZPC_TradeLevel", 0, XShift2, YShift+16*2+ButtonMarginSize*2, 25, 15, Corner, "TL", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
                  ObjectSetString(0, "TZPC_TradeLevel", OBJPROP_TOOLTIP, "Turn ON Trade Levels");
            } else {
               // show trade levels
               ChartSetInteger(ChartID(), CHART_SHOW_TRADE_LEVELS, true);
               ButtonCreate(0, "TZPC_TradeLevel", 0, XShift2, YShift+16*2+ButtonMarginSize*2, 25, 15, Corner, "TL", "Arial", Text_Font_Size + 1, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
                  ObjectSetString(0, "TZPC_TradeLevel", OBJPROP_TOOLTIP, "Turn OFF Trade Levels");
            }
            //ChartRedraw(0);
         }
      }
      
      //--- Detect a change in chart scalefix 'from outside' (user or another indicator changed scalefix)
      if (Show_ChartScaleFix) {
         bool isFixedScale = (bool)ChartGetInteger(0,CHART_SCALEFIX);
         if(isFixedScale!=ChartProperties.isFixedScale) {
            //Print("CHANGE DETECTED on CHART_SCALEFIX ",isFixedScale);
            ChartProperties.isFixedScale = isFixedScale;
               if (!isFixedScale) {
                  //Print("SCALEFIX was true => NOW set to FALSE 'from outside'");
                  //ChartSetInteger(0, CHART_SCALEFIX, 0, FALSE);
                  ObjectDelete(ChartID(),"TZPC_ScaleFix+");
                  ObjectDelete(ChartID(),"TZPC_ScaleFix-");
                  ObjectDelete(ChartID(),"TZPC_ScaleFix");
                  ButtonCreate(0, "TZPC_ScaleFix", 0, XShift2, YShift+16+ButtonMarginSize, 25, 15, Corner, "CS", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
                  ObjectSetString(0, "TZPC_ScaleFix", OBJPROP_TOOLTIP, "Turn ON Chart ScaleFix");
               } else {
                  //Print("SCALEFIX was false => NOW set to TRUE 'from outside'");
                  ObjectDelete(ChartID(),"TZPC_ScaleFix");
                  ButtonCreate(0, "TZPC_ScaleFix", 0, XShift2, YShift+16+ButtonMarginSize, 25, 15, Corner, "CS", "Arial", Text_Font_Size + 1, Text_Color_Active, chart_color_background_active, Border_Color_Active, false, false, false, false, 0);
                  ObjectSetString(0, "TZPC_ScaleFix", OBJPROP_TOOLTIP, "Turn OFF Chart ScaleFix");
                  ButtonCreate(0, "TZPC_ScaleFix+", 0, XShift2 + 26 + ButtonMarginSize, YShift+16+ButtonMarginSize, 25, 15, Corner, "CS+", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);
                  ButtonCreate(0, "TZPC_ScaleFix-", 0, XShift2 + 52 + 2*ButtonMarginSize, YShift+16+ButtonMarginSize, 25, 15, Corner, "CS-", "Arial", Text_Font_Size + 1, Text_Color_Inactive, chart_color_background_inactive, Border_Color_Inactive, false, false, false, false, 0);         
               }
            //ChartRedraw(0);
         }
      }
      
      //--- Detect a change in chart size or properties 'from outside' (user or another indicator changed scale)
      if (Show_Zo || Show_Zi) {
         int scale = (int)ChartScaleGet();
         if(scale!=ChartProperties.scale) {
            //Print("CHANGE DETECTED on CHART_SCALE ",scale);
            ChartProperties.scale = scale;
            if (scale==0) {
               ObjectSetInteger(0, "TZPC_ZommOutButton", OBJPROP_COLOR, Text_Color_Inactive2);
            }
            else if (scale==5) {
               ObjectSetInteger(0, "TZPC_ZommInButton", OBJPROP_COLOR, Text_Color_Inactive2);
            }
            else {
               ObjectSetInteger(0, "TZPC_ZommInButton", OBJPROP_COLOR, Text_Color_Inactive);
               ObjectSetInteger(0, "TZPC_ZommOutButton", OBJPROP_COLOR, Text_Color_Inactive);
            }
            //ChartRedraw(0);
         }
      }
   } //END if(id == CHARTEVENT_CHART_CHANGE) {
}
// +------------------------------------------------------------------+
// |                                                                  |
// +------------------------------------------------------------------+
bool ButtonCreate(const long chart_ID            = 0,               // chart's ID
                  const string name              = "Button",        // button name
                  const int sub_window           = 0,               // subwindow index
                  const int xx                   = 0,                // X coordinate
                  const int yy                   = 0,                // Y coordinate
                  const int width                = 50,              // button width
                  const int height               = 18,              // button height
                  const ENUM_BASE_CORNER cornerr = CORNER_LEFT_UPPER,   // chart corner for anchoring
                  const string text              = "Button",        // text
                  const string font              = "Arial",         // font
                  const int font_size            = 10,              // font size
                  const color clr                = clrBlack,        // text color
                  const color back_clr           = C'236,233,216', // background color
                  const color border_clr         = clrNONE,         // border color
                  const bool state               = false,           // pressed/released
                  const bool back                = false,           // in the background
                  const bool selection           = false,           // highlight to move
                  const bool hidden              = true,            // hidden in the object list
                  const long z_order             = 0)              // priority for mouse click
{
   // --- reset the error value
   ResetLastError();
   // --- create the button
   if (ObjectFind(chart_ID, name)<0) {
      if (!ObjectCreate(chart_ID, name, OBJ_BUTTON, sub_window, 0, 0)) {
         Print(__FUNCTION__,
            ": failed to create the button! Error code = ", GetLastError());
         return(false);
      }
      // --- set button coordinates
      ObjectSetInteger(chart_ID, name, OBJPROP_XDISTANCE, (int)(xx * DPIScaling));
      ObjectSetInteger(chart_ID, name, OBJPROP_YDISTANCE, (int)(yy * DPIScaling));
      // --- set button size
      ObjectSetInteger(chart_ID, name, OBJPROP_XSIZE, (int)(width * DPIScaling));
      ObjectSetInteger(chart_ID, name, OBJPROP_YSIZE, (int)(height * DPIScaling));
      // --- set the chart's corner, relative to which point coordinates are defined
      ObjectSetInteger(chart_ID, name, OBJPROP_CORNER, cornerr);
      // --- set the text
      ObjectSetString(chart_ID, name, OBJPROP_TEXT, text);
      // --- set text font
      ObjectSetString(chart_ID, name, OBJPROP_FONT, font);
      // --- set font size
      ObjectSetInteger(chart_ID, name, OBJPROP_FONTSIZE, font_size);
      // --- set text color
      ObjectSetInteger(chart_ID, name, OBJPROP_COLOR, clr);
      // --- set background color
      ObjectSetInteger(chart_ID, name, OBJPROP_BGCOLOR, back_clr);
      // --- set border color
      ObjectSetInteger(chart_ID, name, OBJPROP_BORDER_COLOR, border_clr);
      // --- display in the foreground (false) or background (true)
      ObjectSetInteger(chart_ID, name, OBJPROP_BACK, back);
      // --- set button state
      ObjectSetInteger(chart_ID, name, OBJPROP_STATE, state);
      // --- enable (true) or disable (false) the mode of moving the button by mouse
      ObjectSetInteger(chart_ID, name, OBJPROP_SELECTABLE, selection);
      ObjectSetInteger(chart_ID, name, OBJPROP_SELECTED, selection);
      // --- hide (true) or display (false) graphical object name in the object list
      ObjectSetInteger(chart_ID, name, OBJPROP_HIDDEN, hidden);
      // --- set the priority for receiving the event of a mouse click in the chart
      ObjectSetInteger(chart_ID, name, OBJPROP_ZORDER, z_order);
      // --- successful execution
   }
   return(true);
}
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Get chart scale (from 0 to 5).                                   |
// +------------------------------------------------------------------+
int ChartScaleGet(const long chart_ID = 0) {
   // --- prepare the variable to get the property value
   long result = -1;

   // --- reset the error value
   ResetLastError();
   // --- receive the property value
   if (!ChartGetInteger(chart_ID, CHART_SCALE, 0, result)) {
      // --- display the error message in Experts journal
      Print(__FUNCTION__ + ", Error Code = ", GetLastError());
   }
   // --- return the value of the chart property
   return((int)result);
}

// +------------------------------------------------------------------+
// | Set chart scale (from 0 to 5).                                   |
// +------------------------------------------------------------------+
bool ChartScaleSet(const long value, const long chart_ID = 0) {
   // --- reset the error value
   ResetLastError();
   // --- set property value
   if (!ChartSetInteger(chart_ID, CHART_SCALE, 0, value)) {
      // --- display the error message in Experts journal
      Print(__FUNCTION__ + ", Error Code = ", GetLastError());
      return(false);
   }
   // --- successful execution
   return(true);
}


//+--------------------------------------------------------------------------------+ 
//| The function receives the value of the chart maximum in the main window or a   | 
//| subwindow.                                                                     | 
//+--------------------------------------------------------------------------------+ 
double ChartPriceMax(const long chart_ID=0,const int sub_window=0) 
  { 
//--- prepare the variable to get the result 
   double result=EMPTY_VALUE; 
//--- reset the error value 
   ResetLastError(); 
//--- receive the property value 
   if(!ChartGetDouble(chart_ID,CHART_PRICE_MAX,sub_window,result)) 
     { 
      //--- display the error message in Experts journal 
      Print(__FUNCTION__+", Error Code = ",GetLastError()); 
     } 
//--- return the value of the chart property 
   return(result); 
  }
  
//+---------------------------------------------------------------------------------+ 
//| The function receives the value of the chart minimum in the main window or a    | 
//| subwindow.                                                                      | 
//+---------------------------------------------------------------------------------+ 
double ChartPriceMin(const long chart_ID=0,const int sub_window=0) 
  { 
//--- prepare the variable to get the result 
   double result=EMPTY_VALUE; 
//--- reset the error value 
   ResetLastError(); 
//--- receive the property value 
   if(!ChartGetDouble(chart_ID,CHART_PRICE_MIN,sub_window,result)) 
     { 
      //--- display the error message in Experts journal 
      Print(__FUNCTION__+", Error Code = ",GetLastError()); 
     } 
//--- return the value of the chart property 
   return(result); 
}